# Agaric Drupal 8 development quickstart

FOLLOW THESE INSTRUCTIONS, THEN DELETE THEM (keep rest of README.md):

Note that as you run these commands, they will affect the instructions
portion of this file, so either read the GitLab.com copy or be careful
not to reload the file.

First step is cloning this `agaric_starter` project into a folder with the name of the project you want to start, in the place where you keep local copies of your code.  Not shown here, but don't forget to associate your project with a remote repository on GitLab (follow their instructions for existing repository) or elsewhere.

```
git clone git@gitlab.com:agaric/agaric-starter.git YOUR_NEW_PROFILE
cd YOUR_NEW_PROFILE
rm -rf .git
git init
git add .
git commit -m "Begin new project based on Agaric starter project"
```

Replace all instances below of `YOUR-NEW-PROFILE`, `YOUR_NEW_PROFILE`, and `YOUR NEW PROFILE` with non-caps-lock versions of your profile name.  It can be one word, and then you don't have to worry about dashes vs underscores vs spaces.  The spaces replacements are instances of text only, no code, and by Drupal custom should be "Sentence cased". After changing each line below, run them in order:

```
grep -lr -e 'agaric-starter' * | xargs sed -i 's/agaric-starter/YOUR-NEW-PROFILE/g'
grep -lr -e 'agaric_starter' * | xargs sed -i 's/agaric_starter/YOUR_NEW_PROFILE/g'
grep -lr -e 'Agaric starter' * | xargs sed -i 's/Agaric starter/YOUR NEW PROFILE/g'
rename 's/agaric_starter/YOUR_NEW_PROFILE/' web/profiles/agaric_starter/
rename 's/agaric_starter/YOUR_NEW_PROFILE/' web/profiles/YOUR_NEW_PROFILE/*
rename 's/agaric-starter/YOUR-NEW-PROFILE/' drush/*
```

And there's a bare base theme that we've included, so that "rake css"
doesn't break right off the bat, that you can rename now also to
YOURNEWTHEME with these commands:

```
grep -lr -e 'agstatheme' * | xargs sed -i 's/agstatheme/YOURNEWTHEME/g'
rename 's/agstatheme/YOURNEWTHEME/' web/themes/agstatheme/
rename 's/agstatheme/YOURNEWTHEME/' web/themes/YOURNEWTHEME/*
rename 's/agstatheme/YOURNEWTHEME/' web/themes/YOURNEWTHEME/sass/*

```

BACK TO YOUR REGULARLY SCHEDULED README

This guide helps you jumpstart working on a Drupal 8 project with Agaric. It assumes you are familiar with git and working on the command line.

## Install Virtualbox and Vagrant

[Download and install Virtualbox](https://www.virtualbox.org/wiki/Downloads)

[Download and install Vagrant](http://www.vagrantup.com/downloads.html">http://www.vagrantup.com/downloads.html)

## Clone the repository and bring up the virtual development environment

```
$ git clone git@gitlab.com:agaric/agaric-starter.git
$ cd agaric-starter
$ vagrant up
```

If this is your first project using the box specified in the Vagrantfile it will be downloaded. This can take a while.

Add the IP address and host name combination to your /etc/hosts, getting the values from config.vm.network ip and config.vm.hostname in the Vagrantfile.

## Tell git who you are

```
$ git config --global user.name 'Jean R. Hacker'
$ git config --global user.email 'jean@agaric.com'
```

## Create a personal excludesfile

```
$ touch ~/.gitignore
$ git config --global core.excludesfile ~/.gitignore
```

Patterns which a user wants git to ignore in all situations (e.g., backup or temporary files generated by the user’s editor of choice) generally go into a file specified by core.excludesfile in the user’s ~/.gitconfig. — gitignore manual page.

## Develop

Pick a ticket, create a branch referencing the ticket number, e.g. `git checkout -b project-123`. Commit your code in small chunks capturing logical steps and follow the [Drupal coding standards](https://drupal.org/coding-standards) and the [guidelines for commit messages](http://tbaggery.com/2008/04/19/a-note-about-git-commit-messages.html). All configuration that accompanies your code, e.g. creating fields and content types, must be in the `config` directory or scripted in an update hook. Once your work is done request a review and eventually your code will get merged into the master branch.

### Export configuration

```
$ drush -y cex
```

And then ```git add config``` and review diff before committing.

### Adding contributed modules

With `composer require ...` you can add new dependencies to your installation:

```
$ cd /vagrant
$ composer require drupal/honeypot:8.*
```

### Updating Drupal core

1. Update the version number of `drupal/core` in composer.json.
1. Run `composer update drupal/core`.
1. Run `./scripts/drupal/update-scaffold [drush-version-spec]` to update files in the `web` directory, where `drush-version-spec` is an optional identifier acceptable to Drush, e.g. `drupal-8.0.x` or `drupal-8.1.x`, corresponding to the version you specified in `composer.json`. (Defaults to `drupal-8`, the latest stable release.) Review the files for any changes and restore any customizations to `.htaccess` or `robots.txt`.
1. Commit everything all together in a single commit, so `web` will remain in sync with the `core` when checking out branches or running `git bisect`.
